// This file is generated by kconfig_compiler_kf5 from kalendarconfig.kcfg.
// All changes you do to this file will be lost.
#ifndef KALENDARCONFIG_H
#define KALENDARCONFIG_H

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class KalendarConfig : public KConfigSkeleton
{
  Q_OBJECT
  public:
    enum EnumLocationMarker { Circle, Pin };
    Q_ENUM(EnumLocationMarker)
    enum EnumLastOpenedView { MonthView, ScheduleView, TodoView, WeekView, ThreeDayView, DayView, ContactView, MailView };
    Q_ENUM(EnumLastOpenedView)
    enum EnumMonthGridMode { SwipeableMonthGrid, BasicMonthGrid };
    Q_ENUM(EnumMonthGridMode)
    enum EnumWeekdayLabelAlignment { Left, Center, Right };
    Q_ENUM(EnumWeekdayLabelAlignment)
    enum EnumWeekdayLabelLength { Full, Abbreviated, Letter };
    Q_ENUM(EnumWeekdayLabelLength)
    enum EnumHourlyViewMode { SwipeableInternalHourlyView, BasicInternalHourlyView };
    Q_ENUM(EnumHourlyViewMode)
    enum EnumMonthListMode { SwipeableMonthList, BasicMonthList };
    Q_ENUM(EnumMonthListMode)
    enum EnumSort { DueTime, Alphabetically, Priority };
    Q_ENUM(EnumSort)

    static KalendarConfig *self();
    ~KalendarConfig() override;

    /**
      Set Show the Menubar.
    */
    static
    void setShowMenubar( bool v )
    {
      if (v != self()->mShowMenubar && !self()->isShowMenubarImmutable()) {
        self()->mShowMenubar = v;
        Q_EMIT self()->showMenubarChanged();
      }
    }

    Q_PROPERTY(bool showMenubar READ showMenubar WRITE setShowMenubar NOTIFY showMenubarChanged)
    Q_PROPERTY(bool isShowMenubarImmutable READ isShowMenubarImmutable CONSTANT)
    /**
      Get Show the Menubar.
    */
    static
    bool showMenubar()
    {
      return self()->mShowMenubar;
    }

    /**
      Is Show the Menubar. Immutable
    */
    static
    bool isShowMenubarImmutable()
    {
      return self()->isImmutable( QStringLiteral( "showMenubar" ) );
    }

    /**
      Get Show the Menubar. default value
    */
    static
    bool defaultShowMenubarValue()
    {
        return defaultShowMenubarValue_helper();
    }

    /**
      Set Always have mainDrawer.collapsed.
    */
    static
    void setForceCollapsedMainDrawer( bool v )
    {
      if (v != self()->mForceCollapsedMainDrawer && !self()->isForceCollapsedMainDrawerImmutable()) {
        self()->mForceCollapsedMainDrawer = v;
        Q_EMIT self()->forceCollapsedMainDrawerChanged();
      }
    }

    Q_PROPERTY(bool forceCollapsedMainDrawer READ forceCollapsedMainDrawer WRITE setForceCollapsedMainDrawer NOTIFY forceCollapsedMainDrawerChanged)
    Q_PROPERTY(bool isForceCollapsedMainDrawerImmutable READ isForceCollapsedMainDrawerImmutable CONSTANT)
    /**
      Get Always have mainDrawer.collapsed.
    */
    static
    bool forceCollapsedMainDrawer()
    {
      return self()->mForceCollapsedMainDrawer;
    }

    /**
      Is Always have mainDrawer.collapsed. Immutable
    */
    static
    bool isForceCollapsedMainDrawerImmutable()
    {
      return self()->isImmutable( QStringLiteral( "forceCollapsedMainDrawer" ) );
    }

    /**
      Get Always have mainDrawer.collapsed. default value
    */
    static
    bool defaultForceCollapsedMainDrawerValue()
    {
        return defaultForceCollapsedMainDrawerValue_helper();
    }

    /**
      Set Enable maps. NOTE: may cause crashing on some systems.
    */
    static
    void setEnableMaps( bool v )
    {
      if (v != self()->mEnableMaps && !self()->isEnableMapsImmutable()) {
        self()->mEnableMaps = v;
        Q_EMIT self()->enableMapsChanged();
      }
    }

    Q_PROPERTY(bool enableMaps READ enableMaps WRITE setEnableMaps NOTIFY enableMapsChanged)
    Q_PROPERTY(bool isEnableMapsImmutable READ isEnableMapsImmutable CONSTANT)
    /**
      Get Enable maps. NOTE: may cause crashing on some systems.
    */
    static
    bool enableMaps()
    {
      return self()->mEnableMaps;
    }

    /**
      Is Enable maps. NOTE: may cause crashing on some systems. Immutable
    */
    static
    bool isEnableMapsImmutable()
    {
      return self()->isImmutable( QStringLiteral( "enableMaps" ) );
    }

    /**
      Get Enable maps. NOTE: may cause crashing on some systems. default value
    */
    static
    bool defaultEnableMapsValue()
    {
        return defaultEnableMapsValue_helper();
    }

    /**
      Set Enable mail integration
    */
    static
    void setEnableMailIntegration( bool v )
    {
      if (v != self()->mEnableMailIntegration && !self()->isEnableMailIntegrationImmutable()) {
        self()->mEnableMailIntegration = v;
        Q_EMIT self()->enableMailIntegrationChanged();
      }
    }

    Q_PROPERTY(bool enableMailIntegration READ enableMailIntegration WRITE setEnableMailIntegration NOTIFY enableMailIntegrationChanged)
    Q_PROPERTY(bool isEnableMailIntegrationImmutable READ isEnableMailIntegrationImmutable CONSTANT)
    /**
      Get Enable mail integration
    */
    static
    bool enableMailIntegration()
    {
      return self()->mEnableMailIntegration;
    }

    /**
      Is Enable mail integration Immutable
    */
    static
    bool isEnableMailIntegrationImmutable()
    {
      return self()->isImmutable( QStringLiteral( "enableMailIntegration" ) );
    }

    /**
      Get Enable mail integration default value
    */
    static
    bool defaultEnableMailIntegrationValue()
    {
        return defaultEnableMailIntegrationValue_helper();
    }

    /**
      Set Type of marker for showing a place's location.
    */
    static
    void setLocationMarker( EnumLocationMarker v )
    {
      if (v != self()->mLocationMarker && !self()->isLocationMarkerImmutable()) {
        self()->mLocationMarker = v;
        Q_EMIT self()->locationMarkerChanged();
      }
    }

    Q_PROPERTY(EnumLocationMarker locationMarker READ locationMarker WRITE setLocationMarker NOTIFY locationMarkerChanged)
    Q_PROPERTY(bool isLocationMarkerImmutable READ isLocationMarkerImmutable CONSTANT)
    /**
      Get Type of marker for showing a place's location.
    */
    static
    EnumLocationMarker locationMarker()
    {
      return static_cast<EnumLocationMarker>(self()->mLocationMarker);
    }

    /**
      Is Type of marker for showing a place's location. Immutable
    */
    static
    bool isLocationMarkerImmutable()
    {
      return self()->isImmutable( QStringLiteral( "locationMarker" ) );
    }

    /**
      Get Type of marker for showing a place's location. default value
    */
    static
    EnumLocationMarker defaultLocationMarkerValue()
    {
        return static_cast<EnumLocationMarker>(defaultLocationMarkerValue_helper());
    }

    /**
      Set Remember the last opened view.
    */
    static
    void setLastOpenedView( EnumLastOpenedView v )
    {
      if (v != self()->mLastOpenedView && !self()->isLastOpenedViewImmutable()) {
        self()->mLastOpenedView = v;
        Q_EMIT self()->lastOpenedViewChanged();
      }
    }

    Q_PROPERTY(EnumLastOpenedView lastOpenedView READ lastOpenedView WRITE setLastOpenedView NOTIFY lastOpenedViewChanged)
    Q_PROPERTY(bool isLastOpenedViewImmutable READ isLastOpenedViewImmutable CONSTANT)
    /**
      Get Remember the last opened view.
    */
    static
    EnumLastOpenedView lastOpenedView()
    {
      return static_cast<EnumLastOpenedView>(self()->mLastOpenedView);
    }

    /**
      Is Remember the last opened view. Immutable
    */
    static
    bool isLastOpenedViewImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lastOpenedView" ) );
    }

    /**
      Get Remember the last opened view. default value
    */
    static
    EnumLastOpenedView defaultLastOpenedViewValue()
    {
        return static_cast<EnumLastOpenedView>(defaultLastOpenedViewValue_helper());
    }

    /**
      Set Width of the incidence drawer
    */
    static
    void setIncidenceInfoDrawerDrawerWidth( int v )
    {
      if (v != self()->mIncidenceInfoDrawerDrawerWidth && !self()->isIncidenceInfoDrawerDrawerWidthImmutable()) {
        self()->mIncidenceInfoDrawerDrawerWidth = v;
        Q_EMIT self()->incidenceInfoDrawerDrawerWidthChanged();
      }
    }

    Q_PROPERTY(int incidenceInfoDrawerDrawerWidth READ incidenceInfoDrawerDrawerWidth WRITE setIncidenceInfoDrawerDrawerWidth NOTIFY incidenceInfoDrawerDrawerWidthChanged)
    Q_PROPERTY(bool isIncidenceInfoDrawerDrawerWidthImmutable READ isIncidenceInfoDrawerDrawerWidthImmutable CONSTANT)
    /**
      Get Width of the incidence drawer
    */
    static
    int incidenceInfoDrawerDrawerWidth()
    {
      return self()->mIncidenceInfoDrawerDrawerWidth;
    }

    /**
      Is Width of the incidence drawer Immutable
    */
    static
    bool isIncidenceInfoDrawerDrawerWidthImmutable()
    {
      return self()->isImmutable( QStringLiteral( "incidenceInfoDrawerDrawerWidth" ) );
    }

    /**
      Get Width of the incidence drawer default value
    */
    static
    int defaultIncidenceInfoDrawerDrawerWidthValue()
    {
        return defaultIncidenceInfoDrawerDrawerWidthValue_helper();
    }

    /**
      Set Whether the "Tags" section of the mainDrawer is expanded.
    */
    static
    void setTagsSectionExpanded( bool v )
    {
      if (v != self()->mTagsSectionExpanded && !self()->isTagsSectionExpandedImmutable()) {
        self()->mTagsSectionExpanded = v;
        Q_EMIT self()->tagsSectionExpandedChanged();
      }
    }

    Q_PROPERTY(bool tagsSectionExpanded READ tagsSectionExpanded WRITE setTagsSectionExpanded NOTIFY tagsSectionExpandedChanged)
    Q_PROPERTY(bool isTagsSectionExpandedImmutable READ isTagsSectionExpandedImmutable CONSTANT)
    /**
      Get Whether the "Tags" section of the mainDrawer is expanded.
    */
    static
    bool tagsSectionExpanded()
    {
      return self()->mTagsSectionExpanded;
    }

    /**
      Is Whether the "Tags" section of the mainDrawer is expanded. Immutable
    */
    static
    bool isTagsSectionExpandedImmutable()
    {
      return self()->isImmutable( QStringLiteral( "tagsSectionExpanded" ) );
    }

    /**
      Get Whether the "Tags" section of the mainDrawer is expanded. default value
    */
    static
    bool defaultTagsSectionExpandedValue()
    {
        return defaultTagsSectionExpandedValue_helper();
    }

    /**
      Set Whether the "Calendar" or "Contacts" section of the mainDrawer is expanded.
    */
    static
    void setCollectionsSectionExpanded( bool v )
    {
      if (v != self()->mCollectionsSectionExpanded && !self()->isCollectionsSectionExpandedImmutable()) {
        self()->mCollectionsSectionExpanded = v;
        Q_EMIT self()->collectionsSectionExpandedChanged();
      }
    }

    Q_PROPERTY(bool collectionsSectionExpanded READ collectionsSectionExpanded WRITE setCollectionsSectionExpanded NOTIFY collectionsSectionExpandedChanged)
    Q_PROPERTY(bool isCollectionsSectionExpandedImmutable READ isCollectionsSectionExpandedImmutable CONSTANT)
    /**
      Get Whether the "Calendar" or "Contacts" section of the mainDrawer is expanded.
    */
    static
    bool collectionsSectionExpanded()
    {
      return self()->mCollectionsSectionExpanded;
    }

    /**
      Is Whether the "Calendar" or "Contacts" section of the mainDrawer is expanded. Immutable
    */
    static
    bool isCollectionsSectionExpandedImmutable()
    {
      return self()->isImmutable( QStringLiteral( "collectionsSectionExpanded" ) );
    }

    /**
      Get Whether the "Calendar" or "Contacts" section of the mainDrawer is expanded. default value
    */
    static
    bool defaultCollectionsSectionExpandedValue()
    {
        return defaultCollectionsSectionExpandedValue_helper();
    }

    /**
      Set The last used event collection used when creating a event.
    */
    static
    void setLastUsedEventCollection( int v )
    {
      if (v != self()->mLastUsedEventCollection && !self()->isLastUsedEventCollectionImmutable()) {
        self()->mLastUsedEventCollection = v;
        Q_EMIT self()->lastUsedEventCollectionChanged();
      }
    }

    Q_PROPERTY(int lastUsedEventCollection READ lastUsedEventCollection WRITE setLastUsedEventCollection NOTIFY lastUsedEventCollectionChanged)
    Q_PROPERTY(bool isLastUsedEventCollectionImmutable READ isLastUsedEventCollectionImmutable CONSTANT)
    /**
      Get The last used event collection used when creating a event.
    */
    static
    int lastUsedEventCollection()
    {
      return self()->mLastUsedEventCollection;
    }

    /**
      Is The last used event collection used when creating a event. Immutable
    */
    static
    bool isLastUsedEventCollectionImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lastUsedEventCollection" ) );
    }

    /**
      Get The last used event collection used when creating a event. default value
    */
    static
    int defaultLastUsedEventCollectionValue()
    {
        return defaultLastUsedEventCollectionValue_helper();
    }

    /**
      Set The last used todo collection used when creating a todo.
    */
    static
    void setLastUsedTodoCollection( int v )
    {
      if (v != self()->mLastUsedTodoCollection && !self()->isLastUsedTodoCollectionImmutable()) {
        self()->mLastUsedTodoCollection = v;
        Q_EMIT self()->lastUsedTodoCollectionChanged();
      }
    }

    Q_PROPERTY(int lastUsedTodoCollection READ lastUsedTodoCollection WRITE setLastUsedTodoCollection NOTIFY lastUsedTodoCollectionChanged)
    Q_PROPERTY(bool isLastUsedTodoCollectionImmutable READ isLastUsedTodoCollectionImmutable CONSTANT)
    /**
      Get The last used todo collection used when creating a todo.
    */
    static
    int lastUsedTodoCollection()
    {
      return self()->mLastUsedTodoCollection;
    }

    /**
      Is The last used todo collection used when creating a todo. Immutable
    */
    static
    bool isLastUsedTodoCollectionImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lastUsedTodoCollection" ) );
    }

    /**
      Get The last used todo collection used when creating a todo. default value
    */
    static
    int defaultLastUsedTodoCollectionValue()
    {
        return defaultLastUsedTodoCollectionValue_helper();
    }

    /**
      Set Use a popup to view incidence information instead of a drawer.
    */
    static
    void setUseIncidenceInfoPopup( bool v )
    {
      if (v != self()->mUseIncidenceInfoPopup && !self()->isUseIncidenceInfoPopupImmutable()) {
        self()->mUseIncidenceInfoPopup = v;
        Q_EMIT self()->useIncidenceInfoPopupChanged();
      }
    }

    Q_PROPERTY(bool useIncidenceInfoPopup READ useIncidenceInfoPopup WRITE setUseIncidenceInfoPopup NOTIFY useIncidenceInfoPopupChanged)
    Q_PROPERTY(bool isUseIncidenceInfoPopupImmutable READ isUseIncidenceInfoPopupImmutable CONSTANT)
    /**
      Get Use a popup to view incidence information instead of a drawer.
    */
    static
    bool useIncidenceInfoPopup()
    {
      return self()->mUseIncidenceInfoPopup;
    }

    /**
      Is Use a popup to view incidence information instead of a drawer. Immutable
    */
    static
    bool isUseIncidenceInfoPopupImmutable()
    {
      return self()->isImmutable( QStringLiteral( "useIncidenceInfoPopup" ) );
    }

    /**
      Get Use a popup to view incidence information instead of a drawer. default value
    */
    static
    bool defaultUseIncidenceInfoPopupValue()
    {
        return defaultUseIncidenceInfoPopupValue_helper();
    }

    /**
      Set Show Tasks in the calendar views (e.g. month, schedule, etc. views).
    */
    static
    void setShowTodosInCalendarViews( bool v )
    {
      if (v != self()->mShowTodosInCalendarViews && !self()->isShowTodosInCalendarViewsImmutable()) {
        self()->mShowTodosInCalendarViews = v;
        Q_EMIT self()->showTodosInCalendarViewsChanged();
      }
    }

    Q_PROPERTY(bool showTodosInCalendarViews READ showTodosInCalendarViews WRITE setShowTodosInCalendarViews NOTIFY showTodosInCalendarViewsChanged)
    Q_PROPERTY(bool isShowTodosInCalendarViewsImmutable READ isShowTodosInCalendarViewsImmutable CONSTANT)
    /**
      Get Show Tasks in the calendar views (e.g. month, schedule, etc. views).
    */
    static
    bool showTodosInCalendarViews()
    {
      return self()->mShowTodosInCalendarViews;
    }

    /**
      Is Show Tasks in the calendar views (e.g. month, schedule, etc. views). Immutable
    */
    static
    bool isShowTodosInCalendarViewsImmutable()
    {
      return self()->isImmutable( QStringLiteral( "showTodosInCalendarViews" ) );
    }

    /**
      Get Show Tasks in the calendar views (e.g. month, schedule, etc. views). default value
    */
    static
    bool defaultShowTodosInCalendarViewsValue()
    {
        return defaultShowTodosInCalendarViewsValue_helper();
    }

    /**
      Set Show subtasks in the calendar views (e.g. month, schedule, etc. views).
    */
    static
    void setShowSubtodosInCalendarViews( bool v )
    {
      if (v != self()->mShowSubtodosInCalendarViews && !self()->isShowSubtodosInCalendarViewsImmutable()) {
        self()->mShowSubtodosInCalendarViews = v;
        Q_EMIT self()->showSubtodosInCalendarViewsChanged();
      }
    }

    Q_PROPERTY(bool showSubtodosInCalendarViews READ showSubtodosInCalendarViews WRITE setShowSubtodosInCalendarViews NOTIFY showSubtodosInCalendarViewsChanged)
    Q_PROPERTY(bool isShowSubtodosInCalendarViewsImmutable READ isShowSubtodosInCalendarViewsImmutable CONSTANT)
    /**
      Get Show subtasks in the calendar views (e.g. month, schedule, etc. views).
    */
    static
    bool showSubtodosInCalendarViews()
    {
      return self()->mShowSubtodosInCalendarViews;
    }

    /**
      Is Show subtasks in the calendar views (e.g. month, schedule, etc. views). Immutable
    */
    static
    bool isShowSubtodosInCalendarViewsImmutable()
    {
      return self()->isImmutable( QStringLiteral( "showSubtodosInCalendarViews" ) );
    }

    /**
      Get Show subtasks in the calendar views (e.g. month, schedule, etc. views). default value
    */
    static
    bool defaultShowSubtodosInCalendarViewsValue()
    {
        return defaultShowSubtodosInCalendarViewsValue_helper();
    }

    /**
      Set Type of day grid view to be used internally in the month view"
    */
    static
    void setMonthGridMode( EnumMonthGridMode v )
    {
      if (v != self()->mMonthGridMode && !self()->isMonthGridModeImmutable()) {
        self()->mMonthGridMode = v;
        Q_EMIT self()->monthGridModeChanged();
      }
    }

    Q_PROPERTY(EnumMonthGridMode monthGridMode READ monthGridMode WRITE setMonthGridMode NOTIFY monthGridModeChanged)
    Q_PROPERTY(bool isMonthGridModeImmutable READ isMonthGridModeImmutable CONSTANT)
    /**
      Get Type of day grid view to be used internally in the month view"
    */
    static
    EnumMonthGridMode monthGridMode()
    {
      return static_cast<EnumMonthGridMode>(self()->mMonthGridMode);
    }

    /**
      Is Type of day grid view to be used internally in the month view" Immutable
    */
    static
    bool isMonthGridModeImmutable()
    {
      return self()->isImmutable( QStringLiteral( "monthGridMode" ) );
    }

    /**
      Get Type of day grid view to be used internally in the month view" default value
    */
    static
    EnumMonthGridMode defaultMonthGridModeValue()
    {
        return static_cast<EnumMonthGridMode>(defaultMonthGridModeValue_helper());
    }

    /**
      Set Alignment of week day header in month view.
    */
    static
    void setWeekdayLabelAlignment( EnumWeekdayLabelAlignment v )
    {
      if (v != self()->mWeekdayLabelAlignment && !self()->isWeekdayLabelAlignmentImmutable()) {
        self()->mWeekdayLabelAlignment = v;
        Q_EMIT self()->weekdayLabelAlignmentChanged();
      }
    }

    Q_PROPERTY(EnumWeekdayLabelAlignment weekdayLabelAlignment READ weekdayLabelAlignment WRITE setWeekdayLabelAlignment NOTIFY weekdayLabelAlignmentChanged)
    Q_PROPERTY(bool isWeekdayLabelAlignmentImmutable READ isWeekdayLabelAlignmentImmutable CONSTANT)
    /**
      Get Alignment of week day header in month view.
    */
    static
    EnumWeekdayLabelAlignment weekdayLabelAlignment()
    {
      return static_cast<EnumWeekdayLabelAlignment>(self()->mWeekdayLabelAlignment);
    }

    /**
      Is Alignment of week day header in month view. Immutable
    */
    static
    bool isWeekdayLabelAlignmentImmutable()
    {
      return self()->isImmutable( QStringLiteral( "weekdayLabelAlignment" ) );
    }

    /**
      Get Alignment of week day header in month view. default value
    */
    static
    EnumWeekdayLabelAlignment defaultWeekdayLabelAlignmentValue()
    {
        return static_cast<EnumWeekdayLabelAlignment>(defaultWeekdayLabelAlignmentValue_helper());
    }

    /**
      Set Format of weekday name.
    */
    static
    void setWeekdayLabelLength( EnumWeekdayLabelLength v )
    {
      if (v != self()->mWeekdayLabelLength && !self()->isWeekdayLabelLengthImmutable()) {
        self()->mWeekdayLabelLength = v;
        Q_EMIT self()->weekdayLabelLengthChanged();
      }
    }

    Q_PROPERTY(EnumWeekdayLabelLength weekdayLabelLength READ weekdayLabelLength WRITE setWeekdayLabelLength NOTIFY weekdayLabelLengthChanged)
    Q_PROPERTY(bool isWeekdayLabelLengthImmutable READ isWeekdayLabelLengthImmutable CONSTANT)
    /**
      Get Format of weekday name.
    */
    static
    EnumWeekdayLabelLength weekdayLabelLength()
    {
      return static_cast<EnumWeekdayLabelLength>(self()->mWeekdayLabelLength);
    }

    /**
      Is Format of weekday name. Immutable
    */
    static
    bool isWeekdayLabelLengthImmutable()
    {
      return self()->isImmutable( QStringLiteral( "weekdayLabelLength" ) );
    }

    /**
      Get Format of weekday name. default value
    */
    static
    EnumWeekdayLabelLength defaultWeekdayLabelLengthValue()
    {
        return static_cast<EnumWeekdayLabelLength>(defaultWeekdayLabelLengthValue_helper());
    }

    /**
      Set Show week numbers to the side of the month grid.
    */
    static
    void setShowWeekNumbers( bool v )
    {
      if (v != self()->mShowWeekNumbers && !self()->isShowWeekNumbersImmutable()) {
        self()->mShowWeekNumbers = v;
        Q_EMIT self()->showWeekNumbersChanged();
      }
    }

    Q_PROPERTY(bool showWeekNumbers READ showWeekNumbers WRITE setShowWeekNumbers NOTIFY showWeekNumbersChanged)
    Q_PROPERTY(bool isShowWeekNumbersImmutable READ isShowWeekNumbersImmutable CONSTANT)
    /**
      Get Show week numbers to the side of the month grid.
    */
    static
    bool showWeekNumbers()
    {
      return self()->mShowWeekNumbers;
    }

    /**
      Is Show week numbers to the side of the month grid. Immutable
    */
    static
    bool isShowWeekNumbersImmutable()
    {
      return self()->isImmutable( QStringLiteral( "showWeekNumbers" ) );
    }

    /**
      Get Show week numbers to the side of the month grid. default value
    */
    static
    bool defaultShowWeekNumbersValue()
    {
        return defaultShowWeekNumbersValue_helper();
    }

    /**
      Set Set the width of the month grid's borders in pixels.
    */
    static
    void setMonthGridBorderWidth( int v )
    {
      if (v != self()->mMonthGridBorderWidth && !self()->isMonthGridBorderWidthImmutable()) {
        self()->mMonthGridBorderWidth = v;
        Q_EMIT self()->monthGridBorderWidthChanged();
      }
    }

    Q_PROPERTY(int monthGridBorderWidth READ monthGridBorderWidth WRITE setMonthGridBorderWidth NOTIFY monthGridBorderWidthChanged)
    Q_PROPERTY(bool isMonthGridBorderWidthImmutable READ isMonthGridBorderWidthImmutable CONSTANT)
    /**
      Get Set the width of the month grid's borders in pixels.
    */
    static
    int monthGridBorderWidth()
    {
      return self()->mMonthGridBorderWidth;
    }

    /**
      Is Set the width of the month grid's borders in pixels. Immutable
    */
    static
    bool isMonthGridBorderWidthImmutable()
    {
      return self()->isImmutable( QStringLiteral( "monthGridBorderWidth" ) );
    }

    /**
      Get Set the width of the month grid's borders in pixels. default value
    */
    static
    int defaultMonthGridBorderWidthValue()
    {
        return defaultMonthGridBorderWidthValue_helper();
    }

    /**
      Set Type of day grid view to be used internally in the month view"
    */
    static
    void setHourlyViewMode( EnumHourlyViewMode v )
    {
      if (v != self()->mHourlyViewMode && !self()->isHourlyViewModeImmutable()) {
        self()->mHourlyViewMode = v;
        Q_EMIT self()->hourlyViewModeChanged();
      }
    }

    Q_PROPERTY(EnumHourlyViewMode hourlyViewMode READ hourlyViewMode WRITE setHourlyViewMode NOTIFY hourlyViewModeChanged)
    Q_PROPERTY(bool isHourlyViewModeImmutable READ isHourlyViewModeImmutable CONSTANT)
    /**
      Get Type of day grid view to be used internally in the month view"
    */
    static
    EnumHourlyViewMode hourlyViewMode()
    {
      return static_cast<EnumHourlyViewMode>(self()->mHourlyViewMode);
    }

    /**
      Is Type of day grid view to be used internally in the month view" Immutable
    */
    static
    bool isHourlyViewModeImmutable()
    {
      return self()->isImmutable( QStringLiteral( "hourlyViewMode" ) );
    }

    /**
      Get Type of day grid view to be used internally in the month view" default value
    */
    static
    EnumHourlyViewMode defaultHourlyViewModeValue()
    {
        return static_cast<EnumHourlyViewMode>(defaultHourlyViewModeValue_helper());
    }

    /**
      Set Set the height of the all-day header at the top of the week view."
    */
    static
    void setWeekViewAllDayHeaderHeight( int v )
    {
      if (v != self()->mWeekViewAllDayHeaderHeight && !self()->isWeekViewAllDayHeaderHeightImmutable()) {
        self()->mWeekViewAllDayHeaderHeight = v;
        Q_EMIT self()->weekViewAllDayHeaderHeightChanged();
      }
    }

    Q_PROPERTY(int weekViewAllDayHeaderHeight READ weekViewAllDayHeaderHeight WRITE setWeekViewAllDayHeaderHeight NOTIFY weekViewAllDayHeaderHeightChanged)
    Q_PROPERTY(bool isWeekViewAllDayHeaderHeightImmutable READ isWeekViewAllDayHeaderHeightImmutable CONSTANT)
    /**
      Get Set the height of the all-day header at the top of the week view."
    */
    static
    int weekViewAllDayHeaderHeight()
    {
      return self()->mWeekViewAllDayHeaderHeight;
    }

    /**
      Is Set the height of the all-day header at the top of the week view." Immutable
    */
    static
    bool isWeekViewAllDayHeaderHeightImmutable()
    {
      return self()->isImmutable( QStringLiteral( "weekViewAllDayHeaderHeight" ) );
    }

    /**
      Get Set the height of the all-day header at the top of the week view." default value
    */
    static
    int defaultWeekViewAllDayHeaderHeightValue()
    {
        return defaultWeekViewAllDayHeaderHeightValue_helper();
    }

    /**
      Set Type of day list view to be used internally in the schedule view"
    */
    static
    void setMonthListMode( EnumMonthListMode v )
    {
      if (v != self()->mMonthListMode && !self()->isMonthListModeImmutable()) {
        self()->mMonthListMode = v;
        Q_EMIT self()->monthListModeChanged();
      }
    }

    Q_PROPERTY(EnumMonthListMode monthListMode READ monthListMode WRITE setMonthListMode NOTIFY monthListModeChanged)
    Q_PROPERTY(bool isMonthListModeImmutable READ isMonthListModeImmutable CONSTANT)
    /**
      Get Type of day list view to be used internally in the schedule view"
    */
    static
    EnumMonthListMode monthListMode()
    {
      return static_cast<EnumMonthListMode>(self()->mMonthListMode);
    }

    /**
      Is Type of day list view to be used internally in the schedule view" Immutable
    */
    static
    bool isMonthListModeImmutable()
    {
      return self()->isImmutable( QStringLiteral( "monthListMode" ) );
    }

    /**
      Get Type of day list view to be used internally in the schedule view" default value
    */
    static
    EnumMonthListMode defaultMonthListModeValue()
    {
        return static_cast<EnumMonthListMode>(defaultMonthListModeValue_helper());
    }

    /**
      Set Show week headers in schedule view.
    */
    static
    void setShowWeekHeaders( bool v )
    {
      if (v != self()->mShowWeekHeaders && !self()->isShowWeekHeadersImmutable()) {
        self()->mShowWeekHeaders = v;
        Q_EMIT self()->showWeekHeadersChanged();
      }
    }

    Q_PROPERTY(bool showWeekHeaders READ showWeekHeaders WRITE setShowWeekHeaders NOTIFY showWeekHeadersChanged)
    Q_PROPERTY(bool isShowWeekHeadersImmutable READ isShowWeekHeadersImmutable CONSTANT)
    /**
      Get Show week headers in schedule view.
    */
    static
    bool showWeekHeaders()
    {
      return self()->mShowWeekHeaders;
    }

    /**
      Is Show week headers in schedule view. Immutable
    */
    static
    bool isShowWeekHeadersImmutable()
    {
      return self()->isImmutable( QStringLiteral( "showWeekHeaders" ) );
    }

    /**
      Get Show week headers in schedule view. default value
    */
    static
    bool defaultShowWeekHeadersValue()
    {
        return defaultShowWeekHeadersValue_helper();
    }

    /**
      Set Sorting of the taskview.
    */
    static
    void setSort( EnumSort v )
    {
      if (v != self()->mSort && !self()->isSortImmutable()) {
        self()->mSort = v;
        Q_EMIT self()->sortChanged();
      }
    }

    Q_PROPERTY(EnumSort sort READ sort WRITE setSort NOTIFY sortChanged)
    Q_PROPERTY(bool isSortImmutable READ isSortImmutable CONSTANT)
    /**
      Get Sorting of the taskview.
    */
    static
    EnumSort sort()
    {
      return static_cast<EnumSort>(self()->mSort);
    }

    /**
      Is Sorting of the taskview. Immutable
    */
    static
    bool isSortImmutable()
    {
      return self()->isImmutable( QStringLiteral( "sort" ) );
    }

    /**
      Get Sorting of the taskview. default value
    */
    static
    EnumSort defaultSortValue()
    {
        return static_cast<EnumSort>(defaultSortValue_helper());
    }

    /**
      Set Sort order
    */
    static
    void setAscendingOrder( bool v )
    {
      if (v != self()->mAscendingOrder && !self()->isAscendingOrderImmutable()) {
        self()->mAscendingOrder = v;
        Q_EMIT self()->ascendingOrderChanged();
      }
    }

    Q_PROPERTY(bool ascendingOrder READ ascendingOrder WRITE setAscendingOrder NOTIFY ascendingOrderChanged)
    Q_PROPERTY(bool isAscendingOrderImmutable READ isAscendingOrderImmutable CONSTANT)
    /**
      Get Sort order
    */
    static
    bool ascendingOrder()
    {
      return self()->mAscendingOrder;
    }

    /**
      Is Sort order Immutable
    */
    static
    bool isAscendingOrderImmutable()
    {
      return self()->isImmutable( QStringLiteral( "ascendingOrder" ) );
    }

    /**
      Get Sort order default value
    */
    static
    bool defaultAscendingOrderValue()
    {
        return defaultAscendingOrderValue_helper();
    }

    /**
      Set Show all completed subtasks even if the parent task is incomplete
    */
    static
    void setShowCompletedSubtodos( bool v )
    {
      if (v != self()->mShowCompletedSubtodos && !self()->isShowCompletedSubtodosImmutable()) {
        self()->mShowCompletedSubtodos = v;
        Q_EMIT self()->showCompletedSubtodosChanged();
      }
    }

    Q_PROPERTY(bool showCompletedSubtodos READ showCompletedSubtodos WRITE setShowCompletedSubtodos NOTIFY showCompletedSubtodosChanged)
    Q_PROPERTY(bool isShowCompletedSubtodosImmutable READ isShowCompletedSubtodosImmutable CONSTANT)
    /**
      Get Show all completed subtasks even if the parent task is incomplete
    */
    static
    bool showCompletedSubtodos()
    {
      return self()->mShowCompletedSubtodos;
    }

    /**
      Is Show all completed subtasks even if the parent task is incomplete Immutable
    */
    static
    bool isShowCompletedSubtodosImmutable()
    {
      return self()->isImmutable( QStringLiteral( "showCompletedSubtodos" ) );
    }

    /**
      Get Show all completed subtasks even if the parent task is incomplete default value
    */
    static
    bool defaultShowCompletedSubtodosValue()
    {
        return defaultShowCompletedSubtodosValue_helper();
    }

    /**
      Set Dimmer
    */
    static
    void setPastEventsTransparencyLevel( double v )
    {
      if (v != self()->mPastEventsTransparencyLevel && !self()->isPastEventsTransparencyLevelImmutable()) {
        self()->mPastEventsTransparencyLevel = v;
        Q_EMIT self()->pastEventsTransparencyLevelChanged();
      }
    }

    Q_PROPERTY(double pastEventsTransparencyLevel READ pastEventsTransparencyLevel WRITE setPastEventsTransparencyLevel NOTIFY pastEventsTransparencyLevelChanged)
    Q_PROPERTY(bool isPastEventsTransparencyLevelImmutable READ isPastEventsTransparencyLevelImmutable CONSTANT)
    /**
      Get Dimmer
    */
    static
    double pastEventsTransparencyLevel()
    {
      return self()->mPastEventsTransparencyLevel;
    }

    /**
      Is Dimmer Immutable
    */
    static
    bool isPastEventsTransparencyLevelImmutable()
    {
      return self()->isImmutable( QStringLiteral( "pastEventsTransparencyLevel" ) );
    }

    /**
      Get Dimmer default value
    */
    static
    double defaultPastEventsTransparencyLevelValue()
    {
        return defaultPastEventsTransparencyLevelValue_helper();
    }


    enum {
      signalShowMenubarChanged = 1,
      signalForceCollapsedMainDrawerChanged = 2,
      signalEnableMapsChanged = 3,
      signalEnableMailIntegrationChanged = 4,
      signalLocationMarkerChanged = 5,
      signalLastOpenedViewChanged = 6,
      signalIncidenceInfoDrawerDrawerWidthChanged = 7,
      signalTagsSectionExpandedChanged = 8,
      signalCollectionsSectionExpandedChanged = 9,
      signalLastUsedEventCollectionChanged = 10,
      signalLastUsedTodoCollectionChanged = 11,
      signalUseIncidenceInfoPopupChanged = 12,
      signalShowTodosInCalendarViewsChanged = 13,
      signalShowSubtodosInCalendarViewsChanged = 14,
      signalMonthGridModeChanged = 15,
      signalWeekdayLabelAlignmentChanged = 16,
      signalWeekdayLabelLengthChanged = 17,
      signalShowWeekNumbersChanged = 18,
      signalMonthGridBorderWidthChanged = 19,
      signalHourlyViewModeChanged = 20,
      signalWeekViewAllDayHeaderHeightChanged = 21,
      signalMonthListModeChanged = 22,
      signalShowWeekHeadersChanged = 23,
      signalSortChanged = 24,
      signalAscendingOrderChanged = 25,
      signalShowCompletedSubtodosChanged = 26,
      signalPastEventsTransparencyLevelChanged = 27
    };

  Q_SIGNALS:
    void showMenubarChanged();

    void forceCollapsedMainDrawerChanged();

    void enableMapsChanged();

    void enableMailIntegrationChanged();

    void locationMarkerChanged();

    void lastOpenedViewChanged();

    void incidenceInfoDrawerDrawerWidthChanged();

    void tagsSectionExpandedChanged();

    void collectionsSectionExpandedChanged();

    void lastUsedEventCollectionChanged();

    void lastUsedTodoCollectionChanged();

    void useIncidenceInfoPopupChanged();

    void showTodosInCalendarViewsChanged();

    void showSubtodosInCalendarViewsChanged();

    void monthGridModeChanged();

    void weekdayLabelAlignmentChanged();

    void weekdayLabelLengthChanged();

    void showWeekNumbersChanged();

    void monthGridBorderWidthChanged();

    void hourlyViewModeChanged();

    void weekViewAllDayHeaderHeightChanged();

    void monthListModeChanged();

    void showWeekHeadersChanged();

    void sortChanged();

    void ascendingOrderChanged();

    void showCompletedSubtodosChanged();

    void pastEventsTransparencyLevelChanged();

  private:
    void itemChanged(quint64 signalFlag);

  protected:
    KalendarConfig(QObject *parent = nullptr);
    friend class KalendarConfigHelper;


    // General
    bool mShowMenubar;
    static bool defaultShowMenubarValue_helper();
    bool mForceCollapsedMainDrawer;
    static bool defaultForceCollapsedMainDrawerValue_helper();
    bool mEnableMaps;
    static bool defaultEnableMapsValue_helper();
    bool mEnableMailIntegration;
    static bool defaultEnableMailIntegrationValue_helper();
    int mLocationMarker;
    static int defaultLocationMarkerValue_helper();
    int mLastOpenedView;
    static int defaultLastOpenedViewValue_helper();
    int mIncidenceInfoDrawerDrawerWidth;
    static int defaultIncidenceInfoDrawerDrawerWidthValue_helper();

    // MainDrawer
    bool mTagsSectionExpanded;
    static bool defaultTagsSectionExpandedValue_helper();
    bool mCollectionsSectionExpanded;
    static bool defaultCollectionsSectionExpandedValue_helper();

    // Editor
    int mLastUsedEventCollection;
    static int defaultLastUsedEventCollectionValue_helper();
    int mLastUsedTodoCollection;
    static int defaultLastUsedTodoCollectionValue_helper();

    // GeneralView
    bool mUseIncidenceInfoPopup;
    static bool defaultUseIncidenceInfoPopupValue_helper();
    bool mShowTodosInCalendarViews;
    static bool defaultShowTodosInCalendarViewsValue_helper();
    bool mShowSubtodosInCalendarViews;
    static bool defaultShowSubtodosInCalendarViewsValue_helper();

    // MonthView
    int mMonthGridMode;
    static int defaultMonthGridModeValue_helper();
    int mWeekdayLabelAlignment;
    static int defaultWeekdayLabelAlignmentValue_helper();
    int mWeekdayLabelLength;
    static int defaultWeekdayLabelLengthValue_helper();
    bool mShowWeekNumbers;
    static bool defaultShowWeekNumbersValue_helper();
    int mMonthGridBorderWidth;
    static int defaultMonthGridBorderWidthValue_helper();

    // WeekView
    int mHourlyViewMode;
    static int defaultHourlyViewModeValue_helper();
    int mWeekViewAllDayHeaderHeight;
    static int defaultWeekViewAllDayHeaderHeightValue_helper();

    // ScheduleView
    int mMonthListMode;
    static int defaultMonthListModeValue_helper();
    bool mShowWeekHeaders;
    static bool defaultShowWeekHeadersValue_helper();

    // TaskView
    int mSort;
    static int defaultSortValue_helper();
    bool mAscendingOrder;
    static bool defaultAscendingOrderValue_helper();
    bool mShowCompletedSubtodos;
    static bool defaultShowCompletedSubtodosValue_helper();
    double mPastEventsTransparencyLevel;
    static double defaultPastEventsTransparencyLevelValue_helper();

  private:
};

#endif

